Index: orxonox/trunk/src/world.h
===================================================================
--- orxonox/trunk/src/world.h	(revision 2077)
+++ orxonox/trunk/src/world.h	(revision 2190)
@@ -1,26 +1,16 @@
-/**
-  Class representating the game-world
-  
-  It contains a list of players (if multiplayer game), a list of Non-Player-Characters (nps), a list of Environment Entities. All this things together are building the orxonox-world. This class also handels the story-line (track), the world start/stop, init/uninit abilities. It is the middle point of every orxonox world.
-*/
+/*! 
+    \file world.h
+    \brief Holds and manages all game data
+*/ 
 
 #ifndef WORLD_H
 #define WORLD_H
 
-class Player;
-class NPC;
-class Environment;
+#include "stdincl.h"
+
+class Track;
 class WorldEntity;
 
-template<class T> class List;
-
-
-
-//! World Class
-/**
-  Class for World representation
-  
-  It contains a list of players (if multiplayer game), a list of Non-Player-Characters (nps), a list of Environment Entities. All this things together are building the orxonox-world. This class also handels the story-line (track), the world start/stop, init/uninit abilities. It is the middle point of every orxonox world.
-*/
+//! The game environment
 class World {
 
@@ -29,68 +19,89 @@
   ~World ();
 
+	template<typename T> 
+	  T* spawn(Location* loc, WorldEntity* owner);	// template to be able to spawn any derivation of WorldEntity
+	template<typename T> 
+	  T* spawn(Placement* plc, WorldEntity* owner);
 
-
-  float primitiveMove; //!< deprecated, do not use
-
-  Player *localPlayer; //!< a pointer to the local player object
-  Player *player1;     //!< a pointer to the second player object
-  Player *player2;     //!< a pointer to the third player object 
-
-  /*
-  struct playerList {
-    playerList* next;
-    Player* player;
-    int number;
-  };
-  playerList* lastPlayer;
-
-  struct npcList {
-    npcList* next;
-    NPC* npc;
-    int number;
-  };
-  npcList* lastNPC;
-
-  struct envList {
-    envList* next;
-    Environment* env;
-    int number;
-  };
-  envList* lastEnv;
-  */
-
-
-  void loadWorld();
-  void unloadWorld();
-  void pauseWorld();
-  void saveGameState(char* filename);
-  
-
-  bool addPlayer(Player* player);
-  bool removePlayer(Player* player);
-  Player* getLocalPlayer();
-  bool addNPC(NPC* npc);
-  bool removeNPC(NPC* npc);
-  bool addEnv(Environment* env);
-  bool removeEnv(Environment* env);
-
-  
-  void drawWorld(void);
-  void initEnvironement(void);
-  void setWorldStep(float step);
-  void updateWorld(void);
-  void detectCollision(void);
-  void testThaTest(void);
-
+	void time_slice (Uint32 deltaT);
+	void collide ();
+	void draw ();
+	void update ();	// maps Locations to Placements
+	void calc_camera_pos (Location* loc, Placement* plc);
+	
+	void unload ();
+	
+	void load_debug_level ();
+	
  private:
-  float surface[120][120]; //!< deprecated: used to build a surface
-  float step; //!< this is the step
-
-  List<WorldEntity*> *playerList; //!< the list of players, usualy very short
-  List<WorldEntity*> *npcList;  //!< list of non player characters (npc)
-  List<WorldEntity*> *envList;  //!< list of environment objects
-
+ 
+	List<WorldEntity>* entities;
+	
+		// base level data
+	Track* track;
+	Uint32 tracklen;
+	Vector* pathnodes;
 
 };
 
+/**
+    \brief spawn a new WorldEntity at a Location
+    \param loc: the Location where the Entity should be spawned
+    \param owner: a pointer to the parent of the Entity
+    \return a pointer to the new WorldEntity or NULL if there was an error
+    
+    You can use this function to spawn any derivation of WorldEntity you want, just specify the desired
+    class within the template specification brackets. Do not attempt to spawn any classes that have NOT been
+    derived from WorldEntity, you won't even be able to compile the code. Note that this version of spawn()
+    works with both free and bound WorldEntities.
+*/ 
+template<typename T> T* World::spawn(Location* loc = NULL, WorldEntity* owner = NULL)
+{
+	Location zeroloc;
+	T* entity = new T();
+	entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
+	if( loc == NULL)
+	{
+		zeroloc.dist = 0;
+		zeroloc.part = 0;
+		zeroloc.pos = Vector();
+		zeroloc.rot = Quaternion();
+		loc = &zeroloc;
+	}
+	entity->init (loc, owner);
+	if (entity->bFree)
+	{
+		track[loc->part].map_coords( loc, entity->get_placement());
+	}
+	entity->post_spawn ();
+	return entity;
+}
+
+/**
+    \brief spawn a new WorldEntity at a Placement
+    \param lplc: the placement where the Entity should be spawned
+    \param owner: a pointer to the parent of the Entity
+    \return a pointer to the new WorldEntity or NULL if there was an error
+    
+    You can use this function to spawn any FREE derivation of WorldEntity you want, just specify the desired
+    class within the template specification brackets. Do not attempt to spawn any classes that have NOT been
+    derived from WorldEntity, you won't even be able to compile the code. Note that this version of spawn()
+    works with free WorldEntities only, you will provoke an error message if you try to spawn a bound Entity with 
+    a Placement.
+*/ 
+template<typename T> T* World::spawn(Placement* plc, WorldEntity* owner = NULL)
+{
+	T* entity = new T();
+	entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
+	entity->init (plc, owner);
+	if (!entity->bFree)
+	{
+		printf("Can't spawn unfree entity with placement\n"); 
+		entities->remove( (WorldEntity*)entity, LIST_FIND_FW);
+		return NULL;
+	}
+	entity->post_spawn ();
+	return entity;
+}
+
 #endif
Index: orxonox/trunk/src/world_entity.cc
===================================================================
--- orxonox/trunk/src/world_entity.cc	(revision 2077)
+++ orxonox/trunk/src/world_entity.cc	(revision 2190)
@@ -13,5 +13,5 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer: ...
+   co-programmer: Christian Meyer
 */
 
@@ -19,115 +19,101 @@
 
 #include "world_entity.h"
-
-#include "vector.h"
+#include "stdincl.h"
+#include "collision.h"
 
 using namespace std;
 
-
 /**
-   \brief 
-   \param v:
-   \return 
+   \brief standard constructor
+   
+   Every derived contructor HAS to call the previous one supplying the isFree parameter. This is necessary to distunguish
+   between free and bound entities. The difference between them is simply the fact that the movement of a free entity is
+   not bound to the track of a world. Use this to implement projectile or effect classes that do not have to travel along the track.
+   To specify an entity to be free or bound set the default parameter in the declaration of the constructor.
+   Theoretically you should never have to call the constructor of an Entity directly, for it is called by the spawn() function of the World
+   class. So if you want to create a new entity at any time, call World::spawn(). It will handle everything that is necessary.
 */
-
-/**
-   \brief Constructor
-
-   This Constructor initializises the all WorldEntities. Everything, that is a part of the game-world is a child of WorldEntity. This class implements empty functions for all sort of operation a WorldEntity has to or can implement.
-This is some sort of standard interface to all WorldEntities...
-*/
-WorldEntity::WorldEntity () 
+WorldEntity::WorldEntity (bool isFree) : bFree(isFree)
 {
-  health = 100;
-  speed = 0;
-}
-
-
-WorldEntity::~WorldEntity () {}
-
-/**
-   \brief sets the position of this entity
-   \param position: Vector, pointing (from 0,0,0) to the new position
-*/
-void WorldEntity::setPosition(Vector* position) {} 
-
-/**
-   \brief gets the postion of this entity
-   \return a Vector, pointing (from 0,0,0) to the new position
-*/
-Vector* getPosition() {}
-
-/**
-   \brief sets orientation of this entity
-   \param orientation: vector specifying in which direction the entity looks
-*/
-void WorldEntity::setOrientation(Vector* orientation) {}
-
-/**
-   \brief gets orientation of this entity
-   \return vector specifying in which direction the entity looks
-*/
-Vector* WorldEntity::getOrientation() {}
-
-/**
-   \brief sets the speed of the entity, if any
-   \param speed: the speed in points (openGL points) per seconds
-*/
-void WorldEntity::setSpeed(float speed)
-{
-  this->speed = speed;
+	collisioncluster = NULL;
+	owner = NULL;
 }
 
 /**
-   \brief gets the speed of the entity, if any
-   \return the speed in points (openGL points) per seconds
+	\brief standard destructor
 */
-float WorldEntity::getSpeed()
+WorldEntity::~WorldEntity ()
 {
-  return speed;
+	if( collisioncluster != NULL) delete collisioncluster;
 }
 
 /**
-   \brief sets the health of the entity
-   \param health: number for the life count, normaly {0..100}
+	\brief get the Location of the WorldEntity
+	\return a pointer to location
 */
-void WorldEntity::setHealth(float health)
+Location* WorldEntity::get_location ()
 {
-  this->health = health;
+	return &loc;
 }
 
 /**
-   \brief gets the health of the entity
-   \return number for the life count, normaly {0..100}
+	\brief get the Placement of the WorldEntity
+	\return a pointer to placement
 */
-float WorldEntity::getHealth()
+Placement* WorldEntity::get_placement ()
 {
-  return health;
+	return &place;
 }
 
 /**
-   \brief this method is called every tick
-   \param time: the time since the last frame was painted
-
-   This function is called before every repaint of the world, to update every time dependent variable of the entity. If the entity moves, it has to calculate the new position every tick here in this function. Do not use this for animations.
+	\brief query whether the WorldEntity in question is free
+	\return true if the WorldEntity is free or false if it isn't
 */
-void WorldEntity::tick(float dt) 
-{}
+bool WorldEntity::isFree ()
+{
+  return bFree;
+}
 
 /**
-   \brief the entity is painted to the screen with this function
+	\brief set the WorldEntity's collision hull
+	\param newhull: a pointer to a completely assembled CollisionCluster
+	
+	Any previously assigned collision hull will be deleted on reassignment
+*/
+void WorldEntity::set_collision (CollisionCluster* newhull)
+{
+	if( newhull == NULL) return;
+	if( collisioncluster != NULL) delete collisioncluster;
+	collisioncluster = newhull;
+}
+
+/**
+	\brief this method is called every frame
+	\param time: the time in seconds that has passed since the last tick
+	
+	Handle all stuff that should update with time inside this method (movement, animation, etc.)
+*/
+void WorldEntity::tick(float time) 
+{
+}
+
+/**
+   \brief the entity is drawn onto the screen with this function
 
    This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
 */
-void WorldEntity::paint() 
-{}
+void WorldEntity::draw() 
+{
+}
 
-/* virtual void WorldEntity::actionEvent(Event* event); */
 /**
-   \brief this function is called, when two entities collide
-   \param we: the world entity, with whom it collides
-   \param loc: place where the collision happens
+	\brief this function is called, when two entities collide
+	\param other: the world entity with whom it collides
+	\param ownhitflags: flags to the CollisionCluster subsections that registered an impact
+	\param otherhitflags: flags to the CollisionCluster subsections of the other entity that registered an impact
+
+	Implement behaviour like damage application or other miscellaneous collision stuff in this function
 */
-void WorldEntity::collide(WorldEntity* we, Vector loc) {}
+void WorldEntity::collide(WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags) {}
 
 /**
@@ -141,5 +127,5 @@
 
 /**
-   \brief this function is called, if the entity is to be destroied
+   \brief this function is called when the entity is to be destroied
    
    This can be called, if eg. something realy bad happens :)
@@ -147,23 +133,62 @@
 void WorldEntity::destroy() {}
 
-/**
-   \brief this function is automatically called before the entity enters the world
-*/
-void WorldEntity::entityPreEnter() {}
 
 /**
-   \brief this function is automatically called after the entity enters the world
-
+	\brief basic initialisation for bound Entities
 */
-void WorldEntity::entityPostEnter() {}
+void WorldEntity::init( Location* spawnloc, WorldEntity* spawnowner)
+{
+	loc = *spawnloc;
+	owner = spawnowner;
+}
 
 /**
-   \brief this function is automatically called before the entity quits the world
-
+	\brief basic initialisation for free Entities
 */
-void WorldEntity::entityPreQuit() {}
+void WorldEntity::init( Placement* spawnplc, WorldEntity* spawnowner)
+{
+	place = *spawnplc;
+	owner = spawnowner;
+}
 
 /**
-   \brief this function is automatically called after the entity quits the world
+	\brief this is called immediately after the Entity has been constructed and initialized
+	
+	Put any initialisation code that requires knowledge of location (placement if the Entity is free) and owner of the entity here.
+	DO NOT place such code in the constructor, those variables are set AFTER the entity is constucted.
 */
-void WorldEntity::entityPostQuit() {}
+void WorldEntity::post_spawn ()
+{
+}
+
+/**
+	\brief this handles incoming command messages
+	\param cmd: a pointer to the incoming Command structure
+	
+	Put all code that handles Command messages here, this will mainly be called by the assigned CommandNode but can also be used
+	to send commands from one WorldEntity to another.
+*/
+void WorldEntity::command (Command* cmd)
+{
+}
+
+/**
+	\brief this is called by the local Camera to determine the point it should look at on the WorldEntity
+	\param locbuf: a pointer to the buffer to fill with a location to look at
+	
+	You may put any Location you want into locbuf, the Camera will determine via the corresponding Track how
+	to look at the location you return with this.
+*/
+void WorldEntity::get_lookat (Location* locbuf)
+{
+}
+
+/**
+	\brief this method is called by the world if the WorldEntity leaves valid gamespace
+	
+	For free entities this means it left the Track boundaries. With bound entities it means its Location adresses a
+	place that is not in the world anymore. In both cases you might have to take extreme measures (a.k.a. call destroy).
+*/
+void WorldEntity::left_world ()
+{
+}
Index: orxonox/trunk/src/world_entity.h
===================================================================
--- orxonox/trunk/src/world_entity.h	(revision 2077)
+++ orxonox/trunk/src/world_entity.h	(revision 2190)
@@ -1,70 +1,56 @@
 /*! 
     \file world_entity.h
-    \brief A base class for all objects in the world
-    
-    This is the base class of all objects in the game-world. If you want to have an object in the world, that can realy interact with other objects and that is also dispbayable etc. you have to extend this class and override the needed functions.
-*/ 
-
-
+    \brief Definition of the basic WorldEntity
+*/
 
 #ifndef WORLD_ENTITY_H
 #define WORLD_ENTITY_H
 
-#include "data_tank.h"
+#include "stdincl.h"
 
-class Vector;
-class Ability;
+class CollisionCluster;
 
-//! WorldEntity
-/**
-  A base class for all objects in the world
-
-  This is the base class of all objects in the game-world. If you want to have an object in the world, that can realy interact with other objects and that is also dispbayable etc. you have to extend this class and override the needed functions.
-*/
-class WorldEntity {
+//! Basic class from which all interactive stuff in the world is derived from
+class WorldEntity
+{	
+	friend class World;
 
  public:
-  WorldEntity ();
+  WorldEntity (bool isFree = false);
   ~WorldEntity ();
 
+ 	Location* get_location ();
+ 	Placement* get_placement ();
+ 	void set_collision (CollisionCluster* newhull);
 
-  void setPosition(Vector* position);
-  Vector* getPosition();
-  void setOrientation(Vector* orientation);
-  Vector* getOrientation();
-  void setSpawnPoint(Vector* place);
-  void setSpeed(float speed);
-  float getSpeed();
-  void setHealth(float health);
-  float getHealth();
+ 	bool isFree ();
+ 	
+  //void addAbility(Ability* ability);
+  //void removeAbility(Ability* ability);
 
-  void addAbility(Ability* ability);
-  void removeAbility(Ability* ability);
+	virtual void post_spawn ();
+  virtual void tick (float time);
+  virtual void hit (WorldEntity* weapon, Vector loc);
+  virtual void destroy ();
+  virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);
+ 	virtual void command (Command* cmd);
+  
+  virtual void draw ();
+  virtual void get_lookat (Location* locbuf);
 
-  virtual void tick(float dt);
-  virtual void paint();
-  /* virtual void actionEvent(Event* event); */
-  virtual void collide(WorldEntity* we, Vector loc);
-  virtual void hit(WorldEntity* weapon, Vector loc);
-  virtual void destroy();
-
-  virtual void entityPreEnter();
-  virtual void entityPostEnter();
-  virtual void entityPreQuit();
-  virtual void entityPostQuit();
-
- 
+	virtual void left_world ();
 
  private:
-  Vector* position;    //!< position of the entity
-  Vector* orientation; //!< orientation of the entity
-  /* List of abilities */ 
-  float health; //!< health of the entity, if any
-  float speed; //!< speed of the entity if any
-  /* entity can be in the air or at ground: */
-  int airGround; //!< is it air or bound to the ground (ground=0, air=1)
+  const bool bFree;	
+  bool bCollide;
+  bool bDraw;
+  
+ 	WorldEntity* owner;
+ 	CollisionCluster* collisioncluster;
+ 	Placement place;
+ 	Location loc;
 
-  
-
+	void init( Location* spawnloc, WorldEntity* spawnowner);
+	void init( Placement* spawnplc, WorldEntity* spawnowner);
 };
 
